var filelist = new Array();

$(function() {
    // preventing page from redirecting
    $("html").on("dragover", function(e) {
        e.preventDefault();
        e.stopPropagation();
        //$("h1").text("Drag here");
    });

    $("html").on("drop", function(e) { e.preventDefault(); e.stopPropagation(); });

    // Drag enter
    $('.upload-area').on('dragenter', function (e) {
        e.stopPropagation();
        e.preventDefault();
        //$("h1").text("Drop");
    });

    // Drag over
    $('.upload-area').on('dragover', function (e) {
        e.stopPropagation();
        e.preventDefault();
        //$("h1").text("Drop");
    });

    // Drop
    $('.upload-area').on('drop', function (e) {
        e.stopPropagation();
        e.preventDefault();

        //$("h1").text("Upload");

        var file = e.originalEvent.dataTransfer.files;
        var fd = new FormData();

        fd.append('file', file[0]);

        uploadData(fd);
    });

    // Open file selector on div click
    $("#uploadfilearea").click(function(){
        $("#file").click();
    });

    // file selected
    $("#file").change(function(){
        var fd = new FormData();

        var files = $('#file')[0].files[0];

        fd.append('file',files);

        uploadData(fd);
    });
	
	
    // Drag enter
    $('.upload-area2').on('dragenter', function (e) {
        e.stopPropagation();
        e.preventDefault();
        //$("h1").text("Drop");
    });

    // Drag over
    $('.upload-area2').on('dragover', function (e) {
        e.stopPropagation();
        e.preventDefault();
        //$("h1").text("Drop");
    });

    // Drop
    $('.upload-area2').on('drop', function (e) {
        e.stopPropagation();
        e.preventDefault();

        //$("h1").text("Upload");

        var file = e.originalEvent.dataTransfer.files;
        var fd = new FormData();

        fd.append('myfile', file[0]);

        uploadData2(fd);
    });

    // Open file selector on div click
    $("#uploadfilearea2").click(function(){
        $("#myfile").click();
    });

    // file selected
    $("#myfile").change(function(){
        var fd = new FormData();

        var files = $('#myfile')[0].files[0];

        fd.append('myfile',files);

        uploadData2(fd);
    });	
	
});	



	
function CopyText(str){	
  const el = document.createElement('textarea');
  el.value = str;
  el.setAttribute('readonly', '');
  el.style.position = 'absolute';
  el.style.left = '-9999px';
  document.body.appendChild(el);
  el.select();
  document.execCommand('copy');
  document.body.removeChild(el);
  tinyMCE.execCommand('mceAdvImage');
  return false;
};			

function insertAtCaret(areaId, text) {
  var txtarea = document.getElementById(areaId);
  if (!txtarea) {
    return;
  }

  var scrollPos = txtarea.scrollTop;
  var strPos = 0;
  var br = ((txtarea.selectionStart || txtarea.selectionStart == '0') ?
    "ff" : (document.selection ? "ie" : false));
  if (br == "ie") {
    txtarea.focus();
    var range = document.selection.createRange();
    range.moveStart('character', -txtarea.value.length);
    strPos = range.text.length;
  } else if (br == "ff") {
    strPos = txtarea.selectionStart;
  }

  var front = (txtarea.value).substring(0, strPos);
  var back = (txtarea.value).substring(strPos, txtarea.value.length);
  txtarea.value = front + text + back;
  strPos = strPos + text.length;
  if (br == "ie") {
    txtarea.focus();
    var ieRange = document.selection.createRange();
    ieRange.moveStart('character', -txtarea.value.length);
    ieRange.moveStart('character', strPos);
    ieRange.moveEnd('character', 0);
    ieRange.select();
  } else if (br == "ff") {
    txtarea.selectionStart = strPos;
    txtarea.selectionEnd = strPos;
    txtarea.focus();
  }

  txtarea.scrollTop = scrollPos;
}

function printfilelist(){
	var i;
	var filecontent = "";
	var files = "";
	filecontent += "<table border=0 width=100%>";
	document.getElementById("uploaded_list").innerHTML = "";
	for (i = 0; i < filelist.length; i++){
		filecontent += "<tr><td width=2% style='color: white;'>" + (i+1).toString() + ")</td><td style='border-bottom:1px #a2a8a4 solid; word-wrap: break-word;'>" + "<a href='/tempfiles/" + filelist[i].src + "' style='color: white;'>" + filelist[i].name + "</a></td><td width=15% align=right style='color: white;'>" + filelist[i].size + "</td><td width=10% align=center>" + "<button onclick=\"CopyText(\'/tempfiles/" + filelist[i].src + "\'); return false;\">CopyURL</button></td><td width=5% align=center><button onclick='dellist(" + i.toString() + ")'>X</button></td></tr>";
		files += filelist[i].tempname + '|';
	}
	filecontent += "</table>";	
	document.getElementById("uploaded_list").innerHTML = filecontent;
	document.getElementById("files").value = files;	
}
function dellist(idx){
	filelist.splice(idx, 1);
	printfilelist();
}		

// Sending AJAX request and upload file
function uploadData(formdata){

    $.ajax({
        url: 'ajaxupload',
        type: 'post',
        data: formdata,
        contentType: false,
        processData: false,
        dataType: 'json',
        success: function(response){
//            addThumbnail(response);
			filelist.push(response);
			printfilelist();
        }
    });
}

//$(document).ajaxStop(function(){
    //window.location.reload();
//});

function uploadData2(formdata){

    $.ajax({
        url: 'uploadfile.html',
        type: 'post',
        data: formdata,
        contentType: false,
        processData: false,
        dataType: 'html',
        success: function(response){
//            addThumbnail(response);
			//filelist.push(response);
			//printfilelist();
			window.location.reload();
        }
    });
}

// Added thumbnail
function addThumbnail(data){
    $("#uploadfilearea h1").remove();
    var len = $("#uploadfilearea div.thumbnail").length;

    var num = Number(len);
    num = num + 1;

    var name = data.name;
    var size = convertSize(data.size);
    var src = data.src;

    // Creating an thumbnail
    $("#uploadfilearea").append('<div id="thumbnail_'+num+'" class="thumbnail"></div>');
    $("#thumbnail_"+num).append('<img src="'+src+'" width="100%" height="78%">');
    $("#thumbnail_"+num).append('<span class="size">'+size+'<span>');

}

// Bytes conversion
function convertSize(size) {
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
    if (size == 0) return '0 Byte';
    var i = parseInt(Math.floor(Math.log(size) / Math.log(1024)));
    return Math.round(size / Math.pow(1024, i), 2) + ' ' + sizes[i];
}
